diff --git a/src/test/regress/expected/insert_conflict.out b/src/test/regress/expected/insert_conflict.out
index 1338b2b23e..873b81950b 100644
--- a/src/test/regress/expected/insert_conflict.out
+++ b/src/test/regress/expected/insert_conflict.out
@@ -690,6 +690,9 @@ select * from twoconstraints;
 drop table twoconstraints;
 -- check handling of self-conflicts at various isolation levels
 create table selfconflict (f1 int primary key, f2 int);
+begin transaction isolation level read uncommitted;
+insert into selfconflict values (1,1), (1,2) on conflict do nothing;
+commit;
 begin transaction isolation level read committed;
 insert into selfconflict values (1,1), (1,2) on conflict do nothing;
 commit;
@@ -699,6 +702,11 @@ commit;
 begin transaction isolation level serializable;
 insert into selfconflict values (3,1), (3,2) on conflict do nothing;
 commit;
+begin transaction isolation level read uncommitted;
+insert into selfconflict values (4,1), (4,2) on conflict(f1) do update set f2 = 0;
+ERROR:  ON CONFLICT DO UPDATE command cannot affect row a second time
+HINT:  Ensure that no rows proposed for insertion within the same command have duplicate constrained values.
+commit;
 begin transaction isolation level read committed;
 insert into selfconflict values (4,1), (4,2) on conflict(f1) do update set f2 = 0;
 ERROR:  ON CONFLICT DO UPDATE command cannot affect row a second time
diff --git a/src/test/regress/sql/insert_conflict.sql b/src/test/regress/sql/insert_conflict.sql
index 43691cd335..2f68398503 100644
--- a/src/test/regress/sql/insert_conflict.sql
+++ b/src/test/regress/sql/insert_conflict.sql
@@ -421,6 +421,10 @@ drop table twoconstraints;
 
 create table selfconflict (f1 int primary key, f2 int);
 
+begin transaction isolation level read uncommitted;
+insert into selfconflict values (1,1), (1,2) on conflict do nothing;
+commit;
+
 begin transaction isolation level read committed;
 insert into selfconflict values (1,1), (1,2) on conflict do nothing;
 commit;
@@ -433,6 +437,10 @@ begin transaction isolation level serializable;
 insert into selfconflict values (3,1), (3,2) on conflict do nothing;
 commit;
 
+begin transaction isolation level read uncommitted;
+insert into selfconflict values (4,1), (4,2) on conflict(f1) do update set f2 = 0;
+commit;
+
 begin transaction isolation level read committed;
 insert into selfconflict values (4,1), (4,2) on conflict(f1) do update set f2 = 0;
 commit;
